<Cabbage>
form size(350,100), caption("Stroboscopic Effect")
button    bounds( 10, 5,60, 30), text("Off","On"), channel("OnOff")
line      bounds( 78, 0, 1,100)
numberbox bounds( 90, 5,70, 30), range(-1000,1000,15.777-,1,0.0001), channel("LFOrate"), text("LFO.Rate")
combobox  bounds(165,18,70, 20), text("saw","sine","half-sine"), channel("wave")
numberbox bounds( 90,50,70, 30), range(0,6,1,1,0.01), channel("LFOrange"), text("LFO.Range")
numberbox bounds(165,50,70, 30), range(4,12,8,1,0.01), channel("LFOoffset"), text("LFO.Offset")
line      bounds(243, 0, 1,100)
numberbox bounds(255, 5,70, 30), range(0,1000,6,1,0.0001), channel("SHrate"), text("S&H.Rate")
</Cabbage>

<CsoundSynthesizer>

<CsOptions>
-n -dm0
</CsOptions>

<CsInstruments>

sr = 44100
ksmps = 16
nchnls = 2
0dbfs = 1

giwave       ftgen    0,0,4097,10,1,0,0.2,0,0,0.05,0,0,0,0,0.01,0,0,0,0,0.001
gilfo1       ftgen    0,0,4097,7,0,4096,1
gilfo2       ftgen    0,0,4097,19,1,1,0,1
gilfo3       ftgen    0,0,4097,9,0.5,1,0

instr   1
 ; read in widgets
 kOnOff      chnget   "OnOff"
 gkLFOrate   chnget   "LFOrate"
 gkLFOrange  chnget   "LFOrange"
 gkLFOoffset chnget   "LFOoffset"
 gkSHrate    chnget   "SHrate"
 gkwave      chnget   "wave"
 
 ; turn instr 2 on and off
 if trigger(kOnOff,0.5,0)==1 then
  event "i",2,0,-1
 elseif trigger(kOnOff,0.5,1)==1 then
  turnoff2  2,0,0
 endif
endin

instr   2   ;SAMPLE AND HOLD NOTE SEQUENCER
 aoct        oscilikt gkLFOrange, gkLFOrate, gilfo1+gkwave-1
 kSHTrig     metro    gkSHrate
 if kSHTrig==1 then
    reinit  RESTART_ENVELOPE
 endif
 RESTART_ENVELOPE:
 aenv        expseg   1,0.7,0.001,1,0.001
 rireturn
 aenv        butlp    aenv, 200                  ; smooth envelope interruptions
 aoct        samphold aoct + gkLFOoffset, kSHTrig 
 asig        poscil   0.2*aenv, cpsoct(aoct), giwave
 asig        butlp    asig,8000*aenv
             outs     asig, asig
endin

</CsInstruments>

<CsScore>
i 1 0 3600
</CsScore>

</CsoundSynthesizer>