<Cabbage>
form size(300,200), guirefresh(32), text("Pendulum"), colour("white")
image bounds(0,0,0,0), widgetarray("weight",12), shape("ellipse"), colour("black")
button    bounds(  0,185,20,15), text("-","-"), channel("dec"), latched(0), colour:0("white"), colour:1("white"), fontcolour:0("black"), fontcolour:1("black")
numberbox bounds( 20,170,70,30), channel("time"), range(0,10000,0,1,0.0001), text("time"), colour("white"), textcolour("black"), fontcolour("black")
button    bounds( 90,185,20,15), text("+","+"), channel("inc"), latched(0), colour:0("white"), colour:1("white"), fontcolour:0("black"), fontcolour:1("black")
</Cabbage>

<CsoundSynthesizer>

<CsOptions>
-n -dm0
</CsOptions>

<CsInstruments>

sr 	= 	44100
ksmps 	= 	16
nchnls 	= 	2
0dbfs	=	1

gisine	ftgen	0,0,4096,9,1,1,270

giMToPix	init	400		; scaling sizes to pixels
gix_OS	=	150			; x position offset 
giRad	=	7			; radius of weight (visual only)
giDamp	=	0			; damping (0=no_damping 1=maximum_damping)
giInitAngle	=	75	
giInitAngle	/=	90

instr	1
 gkRefresh	metro	16
 gktime		chnget	"time"
 kdec	chnget	"dec"
 kinc	chnget	"inc"
 if kdec==1 then
  chnset	limit(gktime-0.0001,0,10000),"time"
 endif
 if kinc==1 then
  chnset	limit(gktime+0.0001,0,10000),"time"
 endif
endin

instr	2
 ilen		=	(((60/p4)/(2*$M_PI))^2)*9.81	; calculate length of pendulum  
 kamp	init	giInitAngle
 kamp	=	kamp / (1+(giDamp/kr))  
 kphs	=	gktime*(p4/60)
 kphs	tablei	kphs,gisine,1,0,1
 kphs	*=	kamp
 Sident	sprintf	"weight_ident%d",p5
 kx_pix	=	sin($M_PI*kphs*0.5)*ilen*giMToPix	  
 	printk	1,kphs
 if gkRefresh==1 then
  kx_pix	=	sin($M_PI*kphs*0.5)*ilen*giMToPix	  
  ky_pix	=	cos($M_PI*kphs*0.5)*ilen*giMToPix
  Smsg	sprintfk	"bounds(%d,%d,%d,%d)", kx_pix+gix_OS-(giRad*0.5), ky_pix-(giRad*0.5), giRad, giRad
  	chnset		Smsg, Sident
 endif
endin


</CsInstruments>

<CsScore>
i 1 0 3600
i 2 0 3600 49 1
i 2 0 3600 50 2
i 2 0 3600 51 3
i 2 0 3600 52 4
i 2 0 3600 53 5
i 2 0 3600 54 6
i 2 0 3600 55 7
i 2 0 3600 56 8
i 2 0 3600 57 9
i 2 0 3600 58 10
i 2 0 3600 59 11
i 2 0 3600 60 12
</CsScore>

</CsoundSynthesizer>