<Cabbage>
form size(300,330), guirefresh(16), text("Pendulum"), colour("white")
image bounds(150,0,1,165), colour(200,200,200), shape("sharp"), rotate(0,1,1), identchannel("TrigAngleID")
image bounds(0,0,0,0), widgetarray("bob",12), shape("ellipse"), colour("black")
numberbox bounds(5,170,60,30), text("Time"), channel("time"), range(-100000,10000,0,1,0.01), colour("white"), textcolour("black"), fontcolour("black")
checkbox bounds(75,180,60,15), text("Pause"), channel("pause"), fontcolour("black")
numberbox bounds(135,170,60,30), text("Speed"), channel("speed"), range(-10,10,0.2,1,0.01), colour("white"), textcolour("black"), fontcolour("black")
checkbox bounds(200,180,90,15), text("Hold Pattern"), channel("sync"), fontcolour("black")

numberbox bounds(5,205,55,30), text("Init.Angle"), channel("InitAngle"), range(-90,90,-75,1,1), colour("white"), textcolour("black"), fontcolour("black")
numberbox bounds(65,205,55,30), text("Trig.Angle"), channel("TrigAngle"), range(-90,90,0,1,1), colour("white"), textcolour("black"), fontcolour("black")
numberbox bounds(125,205,55,30), text("Damping"), channel("Damping"), range(0,0.1,0,1,0.0001), colour("white"), textcolour("black"), fontcolour("black")
button    bounds(185,210,50,20), text("Restart","Restart"), channel("Restart")
numberbox bounds(240,205,55,30), text("Size Scale"), channel("MToPix"), range(10,5000,400,1,1), colour("white"), textcolour("black"), fontcolour("black")

image     bounds(  2,240,296,88), colour(200,200,200), outlinecolour("black"), outlinethickness(2), shape("rounded")
label     bounds(  2,242,296,12), text("Pendulum Frequencies [per minute]"), fontcolour("black")
numberbox bounds( 15,255,40,30), text("1"),  channel("F1"),  range(10,500,49,1,0.1), colour("white"), textcolour("black"), fontcolour("black")
numberbox bounds( 60,255,40,30), text("2"),  channel("F2"),  range(10,500,50,1,0.1), colour("white"), textcolour("black"), fontcolour("black")
numberbox bounds(105,255,40,30), text("3"),  channel("F3"),  range(10,500,51,1,0.1), colour("white"), textcolour("black"), fontcolour("black")
numberbox bounds(150,255,40,30), text("4"),  channel("F4"),  range(10,500,52,1,0.1), colour("white"), textcolour("black"), fontcolour("black")
numberbox bounds(195,255,40,30), text("5"),  channel("F5"),  range(10,500,53,1,0.1), colour("white"), textcolour("black"), fontcolour("black")
numberbox bounds(240,255,40,30), text("6"),  channel("F6"),  range(10,500,54,1,0.1), colour("white"), textcolour("black"), fontcolour("black")
numberbox bounds( 15,290,40,30), text("7"),  channel("F7"),  range(10,500,55,1,0.1), colour("white"), textcolour("black"), fontcolour("black")
numberbox bounds( 60,290,40,30), text("8"),  channel("F8"),  range(10,500,56,1,0.1), colour("white"), textcolour("black"), fontcolour("black")
numberbox bounds(105,290,40,30), text("9"),  channel("F9"),  range(10,500,57,1,0.1), colour("white"), textcolour("black"), fontcolour("black")
numberbox bounds(150,290,40,30), text("10"), channel("F10"), range(10,500,58,1,0.1), colour("white"), textcolour("black"), fontcolour("black")
numberbox bounds(195,290,40,30), text("11"), channel("F11"), range(10,500,59,1,0.1), colour("white"), textcolour("black"), fontcolour("black")
numberbox bounds(240,290,40,30), text("12"), channel("F12"), range(10,500,60,1,0.1), colour("white"), textcolour("black"), fontcolour("black")
</Cabbage>

<CsoundSynthesizer>

<CsOptions>
-n -dm0
</CsOptions>

<CsInstruments>

sr 	= 	44100
ksmps 	= 	16
nchnls 	= 	2
0dbfs	=	1

instr	1 ; start pendulums
 gkRefresh	metro	32			; refresh rate
 gkFreqs[]	init	12			; array of pendulum frequency values
 gkRestart	chnget	"Restart"		; manual restart trigger
 gkMToPix	chnget	"MToPix"		; scaling sizes to pixels
 gkFreqs[0]	=	chnget:k("F1")
 gkFreqs[1]	=	chnget:k("F2")
 gkFreqs[2]	=	chnget:k("F3")
 gkFreqs[3]	=	chnget:k("F4")
 gkFreqs[4]	=	chnget:k("F5")
 gkFreqs[5]	=	chnget:k("F6")
 gkFreqs[6]	=	chnget:k("F7")
 gkFreqs[7]	=	chnget:k("F8")
 gkFreqs[8]	=	chnget:k("F9")
 gkFreqs[9]	=	chnget:k("F10")
 gkFreqs[10]	=	chnget:k("F11")
 gkFreqs[11]	=	chnget:k("F12")
 gkL12		=	((60/(2*$M_PI*gkFreqs[11]))^2)*9.81	; length of the last pendulum
 iCount	=	0
 loop:
 event_i "i",2+(iCount/100),0,3600,iCount
 loop_lt	iCount,1,12,loop
endin

instr	2	; a pendulum
 if changed(gkRestart)==1 then			; if a restart trigger has been received
  reinit RESTART				; reinitialise from label
 endif
 RESTART:
 ix_OS	=	150				; x position offset 
 iRad	=	7				; radius of bob (visual only)
 iInitAngle	chnget	"InitAngle"		; initial angle of from which swing begins
 iInitAngle	/=	-90			; in radians
 kSpeed		chnget	"speed"			; speed 1=normal, <1=slow_motion etc.
 kpause		chnget	"pause"			; pause motion if '1'
 ksync		chnget	"sync"			; if '1' all pendulums adopt the same frequency, i.e. pattern is held and repeated
 kTrigAngle	chnget	"TrigAngle"		; angle at which sounds are triggered
 kDamping	chnget	"Damping"		; amount of amplitude damping the pendulums experience
 if changed(kTrigAngle)==1 then			; if sound trigger angle is changed...
  Smsg	sprintfk	"rotate(%f,1,1)",-kTrigAngle/90 *1.57	; create a new string for the Cabbage line widget
  	chnset		Smsg, "TrigAngleID"	; send string to the widget to update its appearance
 endif
 kFreq		=	gkFreqs[p4]		; read frequency value for this pendulum from array
 kL		=	((60/(2*$M_PI*kFreq))^2)*9.81			; calculate length of pendulum  
 if kpause==1 kgoto SKIP			; if pause button is on skip all further processes in this instrument
 if ksync==0 then				; is sync button is off (follow normal behaviour)
  kPeriod	=	2 * $M_PI * sqrt(kL/9.81) * (1/kSpeed)	; period of a pendulum swing - dependent upon pendulum length but not mass
 else
  kPeriod	=	2 * $M_PI * sqrt(gkL12/9.81) * (1/kSpeed)	; sync is on: all pendulums use the same length value
 endif
 kamp	init	iInitAngle			; amplitude initialised according to initial angle of swing set by widget	
 kamp	=	kamp / (1+(kDamping/kr))	; amplit; update elapsed time widget 8 times per secondude of swing, decreased by damping coefficient upon each k-cycle
 kphs	poscil	kamp,1/kPeriod,-1,0.75		; pendulum phase
 ktime	init	0				; initialise elapsed time counter
 if metro:k(8)==1 then				
  chnset	ktime,"time"			; send new time value to numberbox widget
 endif
 if ksync==0 then				; if sync is off, (i.e. in sync-on mode, freeze elapsed time counter)
  ktime	+=	kSpeed/kr 			; increment time (account for speed modulation)
 endif
 Sident	sprintf	"bob_ident%d",p4+1		; generate a string for the ident name for this particular pendulum bob
 if gkRefresh==1 then				; if a (graphic) refresh trigger is received...
  kx_pix	=	sin($M_PI*kphs*0.5)*kL*gkMToPix	; use trig to calculate x position for bob
  ky_pix	=	cos($M_PI*kphs*0.5)*kL*gkMToPix	; use trig to calculate y position for bob
  Smsg	sprintfk	"bounds(%d,%d,%d,%d)", kx_pix + ix_OS - (iRad*0.5), ky_pix -(iRad*0.5), iRad, iRad	; generate message for new position of widget
  	chnset		Smsg, Sident		; send new position message to widget
 endif
 if trigger(kphs,kTrigAngle/90,2)==1 && timeinstk()!=1 then	; if pendulum is crossing the sound trigger line
  icps	=	cpsmidinn(20+((p4+1)*6.717))			; derive a sound frequency value from the length of the pendulum
  event	"i",3,0,440/icps,icps					; trigger a sound event
 endif
 SKIP:
endin

instr	3			; a sound ping
 aenv	expon	1,p3,0.001
 iamp	=	1/octcps(p4)
 asig	poscil	iamp*aenv,p4
 asig	*=	poscil:a(1,300)
 	outs	asig,asig
endin

</CsInstruments>

<CsScore>
i 1 0 3600
</CsScore>

</CsoundSynthesizer>